summaryrefslogtreecommitdiff
path: root/tests/tail-2
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2009-09-07 08:37:08 +0200
committerJim Meyering <meyering@redhat.com>2009-09-07 09:01:14 +0200
commitcdfb703c5da31a798557722df516e0d01dac828a (patch)
tree3689a7d406bc1a640f4127a63c64b2846b765fc6 /tests/tail-2
parent15f26e296b4948edc6c7d33fc1caa6cb50999364 (diff)
downloadcoreutils-cdfb703c5da31a798557722df516e0d01dac828a.tar.xz
tail -f: handle "-"/stdin once again
* src/tail.c (main) [HAVE_INOTIFY]: When stdin (i.e., "-", or no args, but not /dev/stdin) is specified on the command line, don't use inotify. Reported by Bill Brelsford in <http://bugs.debian.org/545422>. * tests/tail-2/follow-stdin: New file. Test for this. * tests/Makefile.am (TESTS): Add the test. * NEWS (Bug fixes): Mention it. This bug was introduced in coreutils-7.5 via commit ae494d4b, 2009-06-02, "tail: use inotify if it is available".
Diffstat (limited to 'tests/tail-2')
-rwxr-xr-xtests/tail-2/follow-stdin41
1 files changed, 41 insertions, 0 deletions
diff --git a/tests/tail-2/follow-stdin b/tests/tail-2/follow-stdin
new file mode 100755
index 000000000..46e7ce80f
--- /dev/null
+++ b/tests/tail-2/follow-stdin
@@ -0,0 +1,41 @@
+#!/bin/sh
+# tail -f - would fail with the initial inotify implementation
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+echo line > exp || framework_failure
+echo line > in || framework_failure
+
+fail=0
+timeout 1 tail -f < in > out 2> err
+
+# tail from coreutils-7.5 would fail
+test $? = 124 || fail=1
+
+# Ensure there was no error output.
+test -s err && fail=1
+
+# Ensure there was
+compare out exp || fail=1
+
+Exit $fail